import { world, ItemStack, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((e) => {
    e.blockComponentRegistry.registerCustomComponent("test:interact_block", new ChangePainting());
    e.blockComponentRegistry.registerCustomComponent("test:cuadro_large", new ChangePainting2());
});
class ChangePainting2 {
    onPlayerInteract(e) {
        const { player, block, dimension } = e;
        const inventory = player.getComponent("inventory").container;
        const selectedSlotIndex = player.selectedSlotIndex;
        const item = inventory.getItem(selectedSlotIndex);
        const direction = block.permutation.getState("minecraft:cardinal_direction");
        const allowedItems = ["test:cuadro_1_item","test:cuadro_2_item","test:cuadro_3_item","test:cuadro_4_item","test:cuadro_5_item","test:cuadro_6_item","test:cuadro_7_item","test:cuadro_8_item","test:cuadro_9_item","test:cuadro_10_item","test:cuadro_11_item","test:cuadro_12_item","test:cuadro_13_item","test:cuadro_14_item","test:cuadro_15_item","test:cuadro_16_item","test:cuadro_17_item","test:cuadro_18_item","test:cuadro_19_item","test:cuadro_20_item"];
        if (item) {
            if (item.typeId.replace(/_item/, '') !== block.typeId && allowedItems.includes(item.typeId)) {
                if (block.typeId !== "test:cuadro_large") {
                    dimension.spawnItem(new ItemStack(`${block.typeId.replace(/_large/, '')}_item`, 1), block.center());
                }
                block.setPermutation(BlockPermutation.resolve(item.typeId.replace(/_item/, '').replace('cuadro', 'cuadro_large'), {"minecraft:cardinal_direction": direction}));
                dimension.playSound("block.itemframe.add_item", block.center());
                if (item.amount > 1) {
                    item.amount -= 1;
                    inventory.setItem(selectedSlotIndex, item);
                } else {
                    inventory.setItem(selectedSlotIndex, undefined);
                }
            }
        }
        if (!item && block.typeId !== "test:cuadro_large") {
            dimension.spawnItem(new ItemStack(`${block.typeId.replace('_large', '')}_item`, 1), block.center());
            block.setPermutation(BlockPermutation.resolve("test:cuadro_large", {"minecraft:cardinal_direction": direction}));
            dimension.playSound("block.itemframe.remove_item", block.center());
        }
    }
}
class ChangePainting {
    onPlayerInteract(e) {
        const { player, block, dimension } = e;
        const inventory = player.getComponent("inventory").container;
        const selectedSlotIndex = player.selectedSlotIndex;
        const item = inventory.getItem(selectedSlotIndex);
        const direction = block.permutation.getState("minecraft:cardinal_direction");
        const allowedItems = ["test:cuadro_1_item","test:cuadro_2_item","test:cuadro_3_item","test:cuadro_4_item","test:cuadro_5_item","test:cuadro_6_item","test:cuadro_7_item","test:cuadro_8_item","test:cuadro_9_item","test:cuadro_10_item","test:cuadro_11_item","test:cuadro_12_item","test:cuadro_13_item","test:cuadro_14_item","test:cuadro_15_item","test:cuadro_16_item","test:cuadro_17_item","test:cuadro_18_item","test:cuadro_19_item","test:cuadro_20_item"];
        if (item) {
            if (item.typeId.replace(/_item/, '') !== block.typeId && allowedItems.includes(item.typeId)) {
                if (block.typeId !== "test:cuadro") {
                    dimension.spawnItem(new ItemStack(`${block.typeId}_item`, 1), block.center());
                }
                block.setPermutation(BlockPermutation.resolve(item.typeId.replace(/_item/, ''), {"minecraft:cardinal_direction": direction}));
                dimension.playSound("block.itemframe.add_item", block.center());
                if (item.amount > 1) {
                    item.amount -= 1;
                    inventory.setItem(selectedSlotIndex, item);
                } else {
                    inventory.setItem(selectedSlotIndex, undefined);
                }
            }
        }
        if (!item && block.typeId !== "test:cuadro") {
            dimension.spawnItem(new ItemStack(`${block.typeId}_item`, 1), block.center());
            block.setPermutation(BlockPermutation.resolve("test:cuadro", {"minecraft:cardinal_direction": direction}));
            dimension.playSound("block.itemframe.remove_item", block.center());
        }
    }
}